﻿using MVCSampleBrowser.Models;
using Syncfusion.JavaScript.DataSources;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using Syncfusion.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.JavaScript.Models;
using System.Web.Script.Serialization;
using System.Reflection;
using Syncfusion.EJ.Export;
using System.Dynamic;
using System.Data;

namespace MvcApplication66.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index(){
            List<ExpandoObject> datasource = new List<ExpandoObject>();
            dynamic row = new ExpandoObject();
            row.id = 1;
            row.verified = true;
            row.name = "Name 1";
            datasource.Add(row);
            dynamic row1 = new ExpandoObject();
            row1.id = 2;
            row1.verified = false;
            row1.name = "Name 2";
            datasource.Add(row1);
            var dt = new DataTable();
            foreach (var col in ((IDictionary<string, object>)datasource[0]))
            {
                dt.Columns.Add(col.Key, col.Value.GetType());
            }
            foreach (dynamic val in datasource)
            {
                IDictionary<string, object> items = val;
                dt.Rows.Add(items.Values.ToArray());
            }
            ViewBag.datasource = dt;
            return View();
        }
        private IEnumerable<ExpandoObject> Add(IEnumerable<ExpandoObject> e, ExpandoObject value)
        {
            foreach (var cur in e)
            {
                yield return cur;
            }
            yield return value;
        }
        public static List<dataSrc> order = new List<dataSrc>()
        {
            new dataSrc(1024,1,true,false),
            new dataSrc(1025,2,false,true),
            new dataSrc(1026,3,false,false),
            new dataSrc(1027,4,true,false),
            new dataSrc(1028,5,false,true),
            new dataSrc(1029,6,true,false),
            new dataSrc(1030,7,false,true),
            new dataSrc(1031,8,true,false),
            new dataSrc(1032,9,false,true),
            new dataSrc(1024,10,true,false),
            new dataSrc(1024,11,true,false),
        };
        public ActionResult UpdateBatch(List<EditableOrder> changed, List<EditableOrder> added, List<EditableOrder> deleted)
        {
            if (added != null)
            {
                for (int i = 0; i < added.Count(); i++)
                {
                    if (added[i].OrderID < 1000)
                        throw new InvalidOperationException("OrderID must be above 1000");
                }
                OrderRepository.Add(added);
            }
            if (changed != null)
                OrderRepository.Update(changed);
            if (deleted != null)
                OrderRepository.Delete(deleted);
            var data = new NorthwindDataContext().OrdersViews.ToList();
            return Json(new { changed =  changed }, JsonRequestBehavior.AllowGet);
        }
        public ActionResult DataSource(Syncfusion.JavaScript.DataManager dm)
        {
            IEnumerable Data = OrderRepository.GetAllRecords().ToList();
            DataResult result = new DataResult();
            DataOperations operation = new DataOperations();
            result.count = Data.AsQueryable().Count();
            if (dm.Skip != null)
                Data = operation.PerformSkip(Data, dm.Skip);
            if(dm.Take != null)
                Data = operation.PerformTake(Data, dm.Take);
            result.result = Data;
            return Json(result, JsonRequestBehavior.AllowGet);
        }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
        }
        public ActionResult Update(EditableOrder value)
        {
            OrderRepository.Update(value);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Insert(EditableOrder value)
        {
            OrderRepository.Add(value);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Delete(int key)
        {
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public class dropDown
        {
            public string Tag { get; set; }
            public int EmployeeID { get; set; }
            public dropDown() { }
            public dropDown(int val, string txt)
            {
                this.Tag = txt;
                this.EmployeeID = val;
            }
        }
        public class dataSrc
        {
            public dataSrc() { }

            public dataSrc(int ordID, int empID, bool V1, bool V2)
            {
                this.OrderID = ordID;
                this.EmployeeID = empID;
                this.Verified1 = V1;
                this.Verified2 = V2;
            }

            public int OrderID { get; set; }
            public int EmployeeID { get; set; }
            public bool Verified1 { get; set; }
            public bool Verified2 { get; set; }

        }
    }
}